* SQLDEMO.PRG
**************************************************************
** THE FOLLOWING IS AN EXAMPLE CLIPPER (S'87 and 5.01)
** PROGRAM USING THE 'C' INTERFACE TO SQL-SERVER.
** ALL FUNCTIONS AVAILABLE ARE USED SO AS TO GIVE THE
** BEGINNER AN IDEA OF HOW THE INTERFACE INTERACTS.
**************************************************************
sqlSERVER = 'ALADDIN'
sqlUSER = 'SA'
sqlPASSWORD = ''
DO logon WITH sqlSERVER, sqlUSER, sqlPASSWORD

Mresult = 0
Mresult = sqllogtime(5)                && SET THE LOGOUT TIME TO 5
if Mresult = 0
   ? "SQLlogtime Failed"
   return
endif

Mresult = sqlqrytime(60)               && ALLOW 60 SECONDS FOR RESPONSE
if Mresult = 0
   ? "SQLqrytime Failed"
   return
endif

sqlmsglvl(0)                           && SET MSG LEVEL TO 0
sqlmsgno(1)                            && ALLOW MSG NUMBERS TO BE APPENDED
sqlpad(0)                              && SET SPACE PADDING OFF

Mresult = sqlfocus(1)                  && 1 - 4 AVAILABLE
? "Background Focus 1 Result Is " + str(Mresult)

Mresult = sqllogin(sqlSERVER,sqlUSER,sqlPASSWORD)
if Mresult = 0
   ? "Login Failed"
   Mresult = sqlerror()
   ? str(Mresult) + " Errors Occurred"
   for i = 1 to Mresult                && PRINT ALL ERRORS
      ? sqlnexterr()
   next
   sqlclrerr()                         && CLEAR THE ERROR BUFFER
   return
else
   ? "Login In Focus Area 1 Accepted!"
endif

Mresult = sqlfocus(2)                  && 1 - 4 AVAILABLE
? "Foreground Focus 2 Result Is " + str(Mresult)

Mresult = sqllogin(pSERVER,pUSER,pPASSWORD)
if Mresult = 0
   ? "Login Failed"
   Mresult = sqlerror()
   ? str(Mresult) + " Errors Occurred"
   for i = 1 to Mresult                && PRINT ALL ERRORS
      ? sqlnexterr()
   next
   sqlclrerr()                         && CLEAR THE ERROR BUFFER
   return
else
   ? "Login In Focus Area 2 Accepted!"
endif

* SO FAR, SO GOOD *

*****************************************************************
** WE WILL NOW PRIME THE DATABASE FOR DATA BY SENDING A QUERY
*****************************************************************
SQLqry1 = "select count(*) from syscolumns" + space(50)
SQLqry2 = "select name from sysobjects where type = 'U'" + space(45)

begin sequence
   clear
   @ 04,05 say 'Query For Background Process'
   @ 05,05 get SQLqry1 picture '@S60'
   @ 07,05 say 'Query For Foreground Process'
   @ 08,05 get SQLqry2 picture '@S60'
   @ 24,00 say 'ESC to Quit'
   read
   if lastkey() = 27                   && ESCAPE
      break
   endif
   keyboard chr(13)

   Mresult = sqlfocus(1)               && SWITCH TO PROCESS 1
   ? "Result For Background Selection Is " + str(Mresult)

   Mresult = sqlbckgrnd(SQLqry1)
   if Mresult = 0
      ? "An Error Has Occurred In The Background Process"
      break
   else
      ? "Background Process Was Successful"
   endif

   do while lastkey() != 27
      clear
      Mresult = sqlfocus(1)            && SWITCH TO PROCESS 1
      Mresult = sqlready()
      if Mresult = 1
         ? "The Background Process Is Ready"
         ShowResults(1)
         break
      else
         ? "The Background Process Is Not Ready"
         @ 07,05 say 'Query For Foreground Process'
         @ 08,05 get SQLqry2 picture '@S60'
         read
         if lastkey() = 27
            exit
         endif
      endif

      Mresult = sqlfocus(2)            && SWITCH TO PROCESS 2
      ? "Result For Foreground Selection Is " + str(Mresult)

      Mresult = sqlquery(SQLqry2)

      ShowResults(2)                    && SHOW RESULTS
   enddo
end sequence

sqllogout()                            && LOGOUT FROM SERVER (BOTH PROCESSES)

? "End of Clipper - SQL Example"
return

******************************************************************************
function ShowResults
******************************************************************************
parameter nProcess

   Mresult = sqlresults()              && SEE IF RESULTS ARE OK
   do case
      case Mresult = -1
         ? "SQL Error"
         break
      case Mresult = -2
         ? "Insufficient Memory"
         break
   endcase

   do while Mresult = 1
      Mcols = sqlnextrow()             && COLUMN COUNT RECEIVED
      ? str(Mcols) + " Columns Were Retrieved"
      do while Mcols > 0
         ?
         for i = 1 to Mcols            && PRINT ALL THE COLUMNS
            ?? sqlnextcol() + "  "
         next
         Mcols = sqlnextrow()          && GET THE NEXT ROW, IF THERE IS
      enddo
      ?
      Mresult = sqlresults()           && SEE IF THERE ARE MORE RESULTS
   enddo
   ? "End Of Results For Process ===>" + str(nProcess)
   ? "Press a Key To Continue..."
   inkey(0)
   clear
return .t.

PROCEDURE logon
PARAMETER sqlSERVER, sqlUSER, sqlPASSWORD
CLEAR
@  1,00 TO 23,79
@  7,08 SAY '                                  '
@  8,08 SAY '                          '
@  9,08 SAY '                      '
@ 10,08 SAY '                                     '
@ 11,08 SAY '                                     '
@ 12,08 SAY '                                     '
@ 13,08 SAY '                             '
@ 14,08 SAY '                             '
@ 15,08 SAY '                                     '
@ 16,08 SAY '                                     '
@ 17,08 SAY '                                   '
@ 18,08 SAY '                      '
@ 19,08 SAY '                            '
@ 20,08 SAY '                                '
SAVE SCREEN
@ 3,17,15,61 BOX '͸ '
@  3,33 SAY ' Server Logon '
@  5,19 SAY 'Server Name []'
@  9,19 SAY '    User ID []'
@ 11,19 SAY '   Password []'
@ 13,17 SAY 'Ĵ'
sqlSERVER = PADR(sqlSERVER, 20)
sqlUSER = PADR(sqlUSER, 20)
sqlPASSWORD = PADR(sqlPASSWORD, 20)
@  5,32 GET sqlSERVER PICTURE '@K!' VALID !""=TRIM(sqlSERVER)
@  9,32 GET sqlUSER PICTURE '@K!' VALID !""=TRIM(sqlSERVER)
@ 11,32 GET sqlPASSWORD PICTURE '@K!'
READ
IF LASTKEY()=27
   QUIT
ENDIF
sqlSERVER = TRIM(sqlSERVER)
sqlUSER = TRIM(sqlUSER)
sqlPASSWORD = TRIM(sqlPASSWORD)
RESTORE SCREEN
@ 24,0 SAY ''
RETURN

FUNCTION padr
PARAMETER string, length
RETURN SUBSTR(string+SPACE(length), 1, length)

* SQLDEMO.PRG

